//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_erp_emcn;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;


public class Test_Ufw_Erp_Emcn extends UiccTestModel {
    
    static final String CAP_FILE_PATH = "uicc/usim/test/usatframework/ufw_erp_emcn";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 50010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 50010102";
    static final String CLASS_AID_2 = "A0000000 871005FF FFFFFF89 50020001";
    static final String APPLET_AID_2 = "A0000000 871005FF FFFFFF89 50020102";
    static final String CLASS_AID_3 = "A0000000 871005FF FFFFFF89 50030001";
    static final String APPLET_AID_3 = "A0000000 871005FF FFFFFF89 50030102";
    
    
    private USimAPITestCardService test;
    APDUResponse response;
    
        
    public Test_Ufw_Erp_Emcn() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    
    public boolean run() {
        initialiseResults();
        
        
        // test script
        test.reset();
        test.terminalProfileSession("1719");
        
        
        // Install package
        test.loadPackage(CAP_FILE_PATH);
          
        /**********************************************************************/
        /** Testcase 1                                                        */ 
        /**********************************************************************/      
        
        // Install Applet1
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
                           "8008" +     // TLV UICC Toolkit application specific parameters
                               "01" +   // V Priority Level
                               "00" +   // V Max. number of timers
                               "00" +   // V Maximum text length for a menu entry
                               "00" +   // V Maximum number of menu entries                              
                               "00" +   // V Install with Maximum number of channels 
                               "00" +   // LV Minimum Security Level field
                               "00" +   // LV TAR Value(s) 
                               "00" );  // V Maximum number of services
        
        // Install Applet2
        test.installApplet(CAP_FILE_PATH, CLASS_AID_2, APPLET_AID_2, 
                           "800A" +     // TLV UICC Toolkit application specific parameters
                               "01" +   // V Priority Level
                               "00" +   // V Max. number of timers
                               "10" +   // V Maximum text length for a menu entry
                               "01" +   // V Maximum number of menu entries                              
                               "01" +   // V position of menu 1
                               "02" +   // V id of menu 1
                               "00" +   // V Install with Maximum number of channels 
                               "00" +   // LV Minimum Security Level field
                               "00" +   // LV TAR Value(s) 
                               "00" );  // V Maximum number of services

        test.reset();
        test.terminalProfileSession("1719");

        //Trigger Applet2 that sends a display text
        response = test.envelopeMenuSelection("100102","");
        addResult(response.checkSw("9114"));
        
        //Trigger Applet1 that posts data
        response = test.envelopeMoShortMessageControl();
        addResult(response.checkSw("9114"));
        addResult(response.checkData("020E8605 91112233 44860591 11223344"));
        
        //Fetch and terminal Response
        test.fetch("14");
        test.terminalResponse("81030121 80820282 81830100");
        
                
        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet1
        response = test.selectApplication(APPLET_AID_1);
        addResult(response.checkData("10" + APPLET_AID_1 + "01CC"));
        
        // Select applet2
        response = test.selectApplication(APPLET_AID_2);
        addResult(response.checkData("10" + APPLET_AID_2 + "01CC"));
        
        test.reset();
        test.terminalProfileSession("1719");

        // Delete Applet1 
        test.deleteApplet(APPLET_AID_1);
        // Delete Applet2 
        test.deleteApplet(APPLET_AID_2);
                                         
        /**********************************************************************/
        /** Testcase 2                                                        */ 
        /**********************************************************************/      
        
        // Install Applet3
        test.installApplet(CAP_FILE_PATH, CLASS_AID_3, APPLET_AID_3, 
                           "800A" +     // TLV UICC Toolkit application specific parameters
                               "01" +   // V Priority Level
                               "00" +   // V Max. number of timers
                               "10" +   // V Maximum text length for a menu entry
                               "01" +   // V Maximum number of menu entries                              
                               "01" +   // V position of menu 1
                               "03" +   // V id of menu 1
                               "00" +   // V Install with Maximum number of channels 
                               "00" +   // LV Minimum Security Level field
                               "00" +   // LV TAR Value(s) 
                               "00" );  // V Maximum number of services

        test.reset();
        test.terminalProfileSession("1719");

        //Trigger Applet3 that sends a display text
        response = test.envelopeMenuSelection("100103","");
        addResult(response.checkSw("9114"));
        
        //Trigger Applet3 that posts data
        response = test.envelopeMoShortMessageControl();
        addResult(response.checkSw("9114"));
        addResult(response.checkData("020E8605 91112233 44860591 11223344"));
        
        //Fetch and terminal Response
        test.fetch("14");
        test.terminalResponse("81030121 80820282 81830100");
        

        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet3
        response = test.selectApplication(APPLET_AID_3);
        addResult(response.checkData("10" + APPLET_AID_3 + "01CC"));
        
        test.reset();
        test.terminalProfileSession("1719");
        // Delete Applet 
        test.deleteApplet(APPLET_AID_3);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);   
        
        return getOverallResult();
    }
}   
